/* GCC */
#include <iostream>

using namespace std;

struct type
{
       int ch[150], length;
};

type mas[2][1248];
int n, m;

void sum( int s, int i, int f, int j )
{
     int length = max( mas[s][i].length, mas[f][j].length ), p = 0;
     for( int k = 0; k < length; k++ )
     {
          mas[s][i].ch[k] += mas[f][j].ch[k] + p;
          p = mas[s][i].ch[k] / 100000;
          mas[s][i].ch[k] %= 100000;
     }
     while( p != 0 ) mas[s][i].ch[length] = p % 100000, p /= 100000, length++;
     mas[s][i].length = length;
     return;
}

void viv( int f, int j )
{
     printf("%d", mas[f][j].ch[mas[f][j].length - 1]);
     for( int k = mas[f][j].length - 2; k >= 0; k-- )
     {
          if( mas[f][j].ch[k] < 10000 ) printf("0");
          if( mas[f][j].ch[k] < 1000 ) printf("0");
          if( mas[f][j].ch[k] < 100 ) printf("0");
          if( mas[f][j].ch[k] < 10 ) printf("0");
          printf("%d", mas[f][j].ch[k]);
     }
     printf("\n");
}

void work( int f, int s )
{
     for( int i = 0; i <= m; i++ )
     {
          mas[s][i].ch[0] = 0;
          mas[s][i].length = 1;
     }
     for( int i = 1; i <= m; i++ )
     {
          for( int j = 0; ( j <= 9 ) && ( i - j > 0 ); j++ ) sum( s, i, f, i - j );
     }
     return;
}

int main()
{
    freopen("numbers.in", "r", stdin);
    freopen("numbers.out", "w", stdout);
    scanf("%d%d", &n, &m);
    
    if( 9 * n < m )
    {
        printf("0\n");
        fclose(stdin);
        fclose(stdout);
        return 0;
    }
    
    if( m == 0 )
    {
        if( n == 1 ) printf("1\n"); else printf("0\n");
        fclose(stdin);
        fclose(stdout);
        return 0;
    }
    
    if( ( 9 * n + 1 - m ) < m ) m = 9 * n + 1 - m;
    
    for( int i = 0; i <= m; i++ )
    {
         mas[0][i].ch[0] = 0;
         mas[0][i].length = 1;
    }
    for( int i = 1; i <= 9; i++ ) mas[0][i].ch[0] = 1;
    
    for( int i = 1; i < n; i++ )
    {
         if( ( i & 1 ) == 1 ) work( 0, 1 ); else work( 1, 0 );
    }
    
    if( ( n & 1 ) == 1 ) viv( 0, m ); else viv( 1, m );
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
