/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

int a , x[2] , y[2] , z[2] , answer;

void turn90()
{
    swap(x[1] , y[1]);
    y[1] = a - y[1];
    swap(x[0] , y[0]);
    y[0] = a - y[0];
}

int dist(int x_1 , int y_1 , int x_2 , int y_2)
{
    return (x_2 - x_1) * (x_2 - x_1) + (y_2 - y_1) * (y_2 - y_1);
}

int main()
{
    freopen("cube.in","r",stdin);
    freopen("cube.out","w",stdout);
    scanf("%d %d%d%d %d%d%d",&a,&x[0],&y[0],&z[0],&x[1],&y[1],&z[1]);
    if ( !x[1] )
        turn90();
    if ( y[1] == a )
        turn90();
    if ( x[1] == a )
        turn90();

    if ( z[1] != a )
    {
        answer = dist(x[0] , y[0] , x[1] , -z[1]);
        if ( a * ((z[1] + a) - x[0]) + x[0] * (-x[1]) - y[0] * (z[1] + a) >= 0 )
            answer = min(answer , dist(x[0] , y[0] , z[1] + a , -x[1]));
        if ( x[0] * (-x[1]) - (y[0]) *(-z[1]) >= 0 )
            answer = min(answer , dist(x[0] , y[0] , -z[1] , -x[1]));
    } else
    {
        answer = dist(x[0] , y[0] , x[1] , -y[1] - a);
        answer = min(answer , dist(x[0] , y[0] , x[1] , 2 * a - y[1]));
        answer = min(answer , dist(x[0] , y[0] , -a - x[1] , y[1]));
        answer = min(answer , dist(x[0] , y[0] , 2 * a - x[1] , y[1]));
        answer = min(answer , dist(x[0] , y[0] , 2 * a + z[1] , -x[1]));
        answer = min(answer , dist(x[0] , y[0] , -a - z[1] , -x[1]));
    };
    printf("%d\n",answer);
    return 0;
}
