/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

int base = 1000000000;

int n , m ;

int dp[1200][2][1000];

int cnt[1200][2];


int main()
{
    freopen("numbers.in","r",stdin);
    freopen("numbers.out","w",stdout);
    scanf("%d %d",&n,&m);
    if ( m > 9 * n ) {
            printf("0\n"); return 0;
    };
    if ( m == 9 * n ) {
            printf("1\n"); return 0;
    };
    for (int i = 1 ; i <= 9 ; i ++ )
    {
        cnt[i][0] ++ ;
        dp[i][0][0] = 1;
    };
    for (int i = 1 ; i < n ; i ++ )
    {
        int cur_index = i & 1;
        int prev_index = cur_index ^ 1;
        for (int j = 1 ; j <= m ; j ++ )
            for (int k = 0 ; k <= min(9 , j) ; k ++ )
            {
                int carry = 0;
                for (int l = 0 ; l < max(cnt[j - k][prev_index] , cnt[j][cur_index]) || carry ; l ++ )
                {
                    if ( l == cnt[j - k][prev_index] )
                        dp[j - k][prev_index][cnt[j - k][prev_index] ++ ] = 0;
                    if ( l == cnt[j][cur_index] )
                        dp[j][cur_index][cnt[j][cur_index] ++ ] = 0;

                    int cur = dp[j - k][prev_index][l] + dp[j][cur_index][l] + carry;
                    dp[j][cur_index][l] = cur % base;
                    carry = cur / base;
                };
            };
        for (int j = 1 ; j <= m ; j ++ )
            cnt[j][prev_index] = 0;
    };
    int index = (n & 1) ^ 1;
    while ( !dp[m][index][cnt[m][index] - 1] )
        --cnt[m][index];

    printf("%d",dp[m][index][cnt[m][index] - 1]);
    for (int i = cnt[m][index] - 2 ; i >= 0 ; i -- )
        printf("%0.9d",dp[m][index][i]);

    printf("\n");
    return 0;
}
